"""grouptype_relevance

Revision ID: e8799ed00992
Revises: 46e4971dc46f
Create Date: 2017-05-30 11:55:48.345622

"""

# revision identifiers, used by Alembic.
revision = 'e8799ed00992'
down_revision = '46e4971dc46f'
branch_labels = None
depends_on = None

from alembic import op
import sqlalchemy as sa


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column('achievements', sa.Column('relevant_grouptype_id', sa.Integer(), nullable=True))
    op.create_index(op.f('ix_achievements_relevant_grouptype_id'), 'achievements', ['relevant_grouptype_id'], unique=False)
    op.create_foreign_key(op.f('fk_achievements_relevant_grouptype_id_grouptypes'), 'achievements', 'grouptypes', ['relevant_grouptype_id'], ['id'], ondelete='RESTRICT')

    op.execute("COMMIT")
    op.execute("""
    DELETE FROM pg_enum
    WHERE enumlabel = 'city'
    AND enumtypid = (
      SELECT oid FROM pg_type WHERE typname = 'relevance_types'
    )
    """)
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint(op.f('fk_achievements_relevant_grouptype_id_grouptypes'), 'achievements', type_='foreignkey')
    op.drop_index(op.f('ix_achievements_relevant_grouptype_id'), table_name='achievements')
    op.drop_column('achievements', 'relevant_grouptype_id')

    op.execute("ALTER TYPE relevance_types ADD value 'city' after 'friends'")
    # ### end Alembic commands ###
